/* UNH CS 758 assignment 3

   hash table-based dictionary for char * keys and void * values
   
   a slightly-generalized implementation of the dict data structure
     declared in babble.h - no reason not to have it handle generic
     void * instead of the specific dist * declared in babble.h

   one way to handle different hash functions is to store a pointer to
   the desired hash function in the data structure.  this just needs
   to be selected properly when the data structure is created.
*/

#include <stdlib.h>  /* malloc */
#include <string.h>  /* strcmp */
#include "utils.h"
#include "babble.h"


/* hash functions */
typedef unsigned int (*hash_t)(char *key);


/***** hash functions *****/


unsigned int bad_hash(char *key)
{
  return 0;
}


unsigned int add3_hash(char *key)
{
  panic("not implemented");
  return 0;
}


unsigned int kr_hash(char *key)
{
  panic("not implemented");
  return 0;
}



unsigned int tab_hash(char *key)
{
  panic("not implemented");
  return 0;
}


/***** dumping bucket counts for harness to plot *****/


/* you probably want to replace void * with a pointer to whatever type
   you define */
void dump_counts(FILE *outfile, void *htd)
{
  /* fprintf(outfile, "bucket %d:\t%d\n", i, n); */
}


/***** implementing the interface functions *****/


/* of course lots more things need to happen here - this is just to
   get you started */
dict *make_ht_dict(hash_t hash)
{
  dict *d;

  /* store hash in your data structure and use it in your lookup and insert */
    
  d = (dict *) malloc(sizeof(dict));
  if (!d) panic("failed to malloc initial dict");
  d->fprint = (fprint_t) dump_counts;
  return d;
}


dict *make_ht_bad_dict(void)
{
  return make_ht_dict(bad_hash);
}


dict *make_ht_add3_dict(void)
{
  return make_ht_dict(add3_hash);
}


dict *make_ht_kr_dict(void)
{
  return make_ht_dict(kr_hash);
}


dict *make_ht_tab_dict(void)
{
  return make_ht_dict(tab_hash);
}


/* EOF */
